/**
 * FocusHighlighter
 * (c) 2007 Alex Bevilacqua [Astley Gilbert Limited]
 * 
 * Extends UIComponent, so any control that implements this class
 * will show a blurred outline of the control when moused-over (if that's even a word :P)
 * GlowFilter fades on mouseOut.
 */
package AGL.DFSThemeDesigner.Handlers
{
	import mx.core.UIComponent;
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;
	import flash.filters.BitmapFilterQuality;
	
	public class FocusHilighter extends UIComponent
	{
		// the target component
		private var _target:UIComponent;
		// alter the controls priority to the glow shows
		private var _zorder:int;
				
		[Bindable] public function get target():UIComponent
		{
			return _target;
		}
		
		public function set target(value:UIComponent):void
		{
			if(_target != null)
			{
				_target.removeEventListener(MouseEvent.MOUSE_OVER, handleMouseOver);
				_target.removeEventListener(MouseEvent.MOUSE_OUT,  handleMouseOut);
			}
			_target = value;
			
			if(_target != null)
			{
				_target.addEventListener(MouseEvent.MOUSE_OVER, handleMouseOver);
				_target.addEventListener(MouseEvent.MOUSE_OUT,  handleMouseOut);
			}
		}
		
		private function handleMouseOver(event:MouseEvent):void
		{
			//trace("handleMouseOver");			
			var glow:GlowFilter = new GlowFilter();						
			var myFilters:Array = new Array();

			glow.color = 0x0000FF;
			glow.blurX = 20;
			glow.blurY = 20;
			glow.strength = 5;
			glow.quality = BitmapFilterQuality.HIGH;			
			
			myFilters.push(glow);
			
			_target.setFocus();
			_target.filters = myFilters;
			
			glow = null; myFilters = null;
		}
		
		private function handleMouseOut(event:MouseEvent):void
		{
			//trace("handleMouseOut");
			_target.filters = new Array();
		}
		
		
	}
}